<?php
namespace Planejamento\Entities;

use Geral\Entities\Base\Servico;
use Geral\Util\Ambiente;
use Geral\Util\DateUtil;
use Geral\Util\TratamentoDeMensagens;
use Setforms2\Shared\Registry;

class Custpadrtp extends Base\Custpadrtp
{

    public static function customSave(
        $nrorg, $cdfilial, $cdservfili, $dtrefcuspadr,
        $cdtipoprat, $vrcustpadrtp,
        $nrorginclusao, $nrorgultatu, $dtinclusao,
        $dtultatu, $cdoperinclusao, $cdoperultatu
    ) {
        try{
            $connection = Registry::getEntityManager();
            $connection->beginTransaction();
            //
            $custpadrtp = new Custpadrtp;
            //
            $custpadrtp->setNrorg($nrorg);
            $custpadrtp->setCdfilial($cdfilial);
            $custpadrtp->setCdservfili($cdservfili);
            $custpadrtp->setDtrefcuspadr($dtrefcuspadr);
            //
            $custpadrtp->setCdtipoprat($cdtipoprat);
            $custpadrtp->setVrcustpadrtp($vrcustpadrtp);
            //
            $custpadrtp->setNrorginclusao($nrorginclusao);
            $custpadrtp->setNrorgultatu($nrorgultatu);
            $custpadrtp->setDtinclusao($dtinclusao);
            $custpadrtp->setDtultatu($dtultatu);
            //$custpadrtp->setDtultatucptp($dtultatucptp);
            $custpadrtp->setCdoperinclusao($cdoperinclusao);
            $custpadrtp->setCdoperultatu($cdoperultatu);
            //
            $custpadrtp->persist();
            //
            $connection->flush();
            $connection->commit();
            //
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

    public static function customUpdate(
        $nrorg, $cdfilial, $cdservfili, $dtrefcuspadr,
        $cdtipoprat, $vrcustpadrtp,
        $nrorgultatu, $dtultatu, $cdoperultatu
    ) {
        try {
            $connection = Registry::getEntityManager();
            $connection->beginTransaction();
            //
            $custpadrtp = Custpadrtp::getObjectByWhere(
                "NRORG = ? AND CDFILIAL = ? AND CDSERVFILI = ?
                 AND DTREFCUSPADR = ? AND CDTIPOPRAT = ?",
                array($nrorg, $cdfilial, $cdservfili, $dtrefcuspadr, $cdtipoprat)
            );
            //
            //$custpadrtp->setCdtipoprat($cdtipoprat);
            $custpadrtp->setVrcustpadrtp($vrcustpadrtp);
            //
            $custpadrtp->setNrorgultatu($nrorgultatu);
            $custpadrtp->setDtultatu($dtultatu);
            //$custpadrtp->setDtultatucptp($dtultatucptp);
            $custpadrtp->setCdoperultatu($cdoperultatu);
            //
            $custpadrtp->persist();
            //
            $connection->flush();
            $connection->commit();
            //

        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

    public static function customDelete($custpadrtp) {
        $connection = Registry::getEntityManager();
        try {
            $connection->beginTransaction();
            //
            $custpadrtp->delete();
            //
            $connection->flush();
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

    public static function verificaExistenciaRegistro(
        $nrorg, $cdfilial, $cdservfili, $dtrefcuspadr
    ) {
        $custpadrtp = Custpadrtp::getObjectByWhere(
            "NRORG = ? AND CDFILIAL = ? AND CDSERVFILI = ? AND DTREFCUSPADR = ?",
            array($nrorg, $cdfilial, $cdservfili, $dtrefcuspadr)
        );
        //
        if (empty($custpadrtp) === true) {
            return false;
        } else {
            return $custpadrtp;
        }
    }



    public static function clonaCustpadrtp(Servico $servicoModelo, Servico $servicoNovo, $conn){


            $codigomodelo = $servicoModelo->getCdservfili();
            $codigonovo = $servicoNovo->getCdservfili();
            $codigofilial = $servicoNovo->getCdfilial();
            $nrorg = Ambiente::getNrorg();
            $registrosCustpadrtp = Custpadrtp::getObjectsByWhere('
                NRORG = ? AND CDSERVFILI = ? AND CDFILIAL = ?',
                array($nrorg,$codigomodelo, $codigofilial ) );


            $operador = Ambiente::getCdOperador();
            $dtAtual = DateUtil::getDataAtual();
            if($registrosCustpadrtp != false){
                /** @var $registronovo Custpadrtp */
                foreach($registrosCustpadrtp as $registromodelo){
                    $registronovo = clone $registromodelo;
                    $registronovo->setCdservfili($codigonovo);
                    $registronovo->setDtultatu($dtAtual);
                    $registronovo->setDtinclusao($dtAtual);
                    $registronovo->setCdoperinclusao($operador);
                    $registronovo->setCdoperultatu($operador);

                    $registronovo->persist();
                    $conn->flush();


                }
            }

    }

}