/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_DESPERCIA                                                */
/* Tabela : DESPERCIA                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 19/11/2003 Mariana Costa                                                   */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_DESPERCIA
BEFORE INSERT OR UPDATE OR DELETE
ON DESPERCIA FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUDCIA := SYSDATE;
   END IF;
   IF UPDATING THEN
      :NEW.DTULTATUDCIA := SYSDATE;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('DESPERCIA', '', 'CDFILIAL='||:OLD.CDFILIAL||';CDCIA='||:OLD.CDCIA||';DTINIDESC='||TO_CHAR(:OLD.DTINIDESC,'YYYYMMDDHH24MISS')||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE DESPERCIA MODIFY DTULTATUDCIA DEFAULT SYSDATE
/
