IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'GERA_NOTAFISCAL_VENDA' AND
	        TYPE = 'P' 			        AND
	        U.UID = O.UID              AND
	        U.NAME = USER)

DROP PROCEDURE GERA_NOTAFISCAL_VENDA
GO

CREATE PROCEDURE GERA_NOTAFISCAL_VENDA

    @P_CDFILIAL      VARCHAR(4),
    @P_CDLOJA        VARCHAR(10),
    @P_CDCAIXA       VARCHAR(200),
    @P_LISTAVENDA    VARCHAR(200),
    @P_CDPRODUTO     VARCHAR(200),
    @P_DTINICIAL     DATETIME,
    @P_DTFINAL       DATETIME,
    @P_CDCLIENTE     VARCHAR(21),
    @P_NMFANTCLIE    VARCHAR(50),
    @P_DTSAIDA       DATETIME,
    @P_CDSERIE       VARCHAR(5),
    @P_CDTIPOOPER    VARCHAR(2),
    @P_CDFILIPROC    VARCHAR(4),
    @P_CDOPERADOR    VARCHAR(12),
    @P_DSMENSAGEM    VARCHAR(200),
    @P_IDTPIJUDESNF  VARCHAR(1) = '',
    @P_NRINSJUDESNF  VARCHAR(20) = '',
    @P_NMRAZSODESNF  VARCHAR(50) = '',
    @P_DSENDEDESTNF  VARCHAR(50) = '',
    @P_NMBAIRDESTNF  VARCHAR(30) = '',
    @P_CDPAIS        VARCHAR(4) = '',
    @P_SGESTADO      VARCHAR(2) = '',
    @P_CDMUNICIPIO   VARCHAR(4) = '',
    @P_NRINSESTDESNF VARCHAR(20) = ''

AS

   DECLARE @V_CDCONTADOR   NUMERIC;
   DECLARE @V_DADOSNF      NUMERIC;
   DECLARE @V_CDPAIS       VARCHAR(4);
   DECLARE @V_SGESTADO     VARCHAR(2);
   DECLARE @V_CDMUNICIPIO  VARCHAR(4);

   DECLARE @V_CDEMPRESA    VARCHAR(2);
   DECLARE @V_CDINSCESTA   VARCHAR(16);
   DECLARE @V_NRMAXITNF    VARCHAR(2);
   DECLARE @V_IDCONMAXITEM VARCHAR(1);

   DECLARE @V_NRLANCTONF   VARCHAR(20);
   DECLARE @V_NRLANCESTQ   VARCHAR(10);

   DECLARE @V_IDTIPORECE   VARCHAR(1);

   DECLARE @V_CDALMOXARIFE VARCHAR(6);
   DECLARE @V_CDLOCALESTOQ VARCHAR(6);

   DECLARE @V_DTSAIDA      DATETIME;
   DECLARE @V_NRCUPOMFIS   VARCHAR(10);

   DECLARE @V_TESTE        VARCHAR(17);
   DECLARE @V_DATE         DATETIME;
   DECLARE @V_NRDADOFISCO  VARCHAR(3)

   /*VARIAVEIS DO CURSOR*/
   DECLARE @C_CDFILIAL      VARCHAR(4);
   DECLARE @C_NRSEQVENDA    VARCHAR(10);
   DECLARE @C_CDCAIXA       VARCHAR(3);
   DECLARE @C_CDLOJA        VARCHAR(10);
   DECLARE @C_DTENTRVENDA   DATETIME;
   DECLARE @C_CDPRODUTO     VARCHAR(10);
   DECLARE @C_NMPRODUTO     VARCHAR(50);
   DECLARE @C_CDARVPROD     VARCHAR(20);
   DECLARE @C_CDPRODESTO    VARCHAR(10);
   DECLARE @C_NRCUPOMFIS    VARCHAR(10);
   DECLARE @C_VRUNITVEND    FLOAT;
   DECLARE @C_QTPRODVEND    FLOAT;
   DECLARE @C_VRDESITVEND   FLOAT;
   DECLARE @C_VRTOTAITEM    FLOAT;
   DECLARE @C_NRMD5ARQTXT   VARCHAR(50);
   DECLARE @C_NRECFCUPOMVE  VARCHAR(30);
   DECLARE @C_NRSERIEIMPVND VARCHAR(50);
   DECLARE @C_DSMODELOECFVE VARCHAR(30);
   DECLARE @C_DSMARCAECFVE  VARCHAR(30);

BEGIN
   SET @V_CDCONTADOR     = 0;
   SET @V_CDPAIS         = NULL;
   SET @V_SGESTADO       = NULL;
   SET @V_CDMUNICIPIO    = NULL;
   SET @V_CDEMPRESA      = NULL;
   SET @V_CDINSCESTA     = NULL;
   SET @V_NRMAXITNF      = NULL;
   SET @V_IDCONMAXITEM   = NULL;
   SET @V_CDALMOXARIFE   = NULL;
   SET @V_CDLOCALESTOQ   = NULL;
   SET @V_IDTIPORECE     = NULL;
   SET @V_NRDADOFISCO    = NULL;


   SET @V_DATE = GETDATE();
   /*Inserir Cliente*/
   SELECT @V_CDCONTADOR = COUNT(*)
   FROM CLIENTE
   WHERE CDCLIENTE = @P_CDCLIENTE;

   IF @V_CDCONTADOR = 0 BEGIN
      INSERT INTO CLIENTE
         (CDCLIENTE, IDTPIJURCLIE, NRINSJURCLIE, NMRAZSOCCLIE, NMFANTCLIE)
      VALUES
         (@P_CDCLIENTE, SUBSTRING(@P_CDCLIENTE,1,1), SUBSTRING(@P_CDCLIENTE,2,20), @P_NMFANTCLIE, @P_NMFANTCLIE);

      SELECT @V_CDPAIS = MAX(CDPAIS), @V_SGESTADO = MAX(SGESTADO), @V_CDMUNICIPIO = MAX(CDMUNICIPIO)
      FROM ENDEFILI
      WHERE CDFILIAL     = @P_CDFILIAL AND
            IDTPENDEFILI = 'P';

      INSERT INTO ENDECLIE
         (CDCLIENTE, IDTPENDECLIE, CDPAIS, SGESTADO, CDMUNICIPIO)
      VALUES
         (@P_CDCLIENTE, 'P', @V_CDPAIS, @V_SGESTADO, @V_CDMUNICIPIO);
   END;

   /*Gerao das Notas Fiscais*/
   SELECT @V_CDEMPRESA = MAX(CDEMPRESA), @V_CDINSCESTA = MAX(CDINSCESTA)
   FROM FILIAL
   WHERE CDFILIAL = @P_CDFILIAL;

   SELECT @V_NRMAXITNF = ISNULL(MAX(NRMAXITNF),10), @V_IDCONMAXITEM = ISNULL(MAX(IDCONMAXITEM),'S')
   FROM SERIENF
   WHERE CDEMPRESA  = @V_CDEMPRESA  AND
         CDINSCESTA = @V_CDINSCESTA AND
         CDSERIE    = @P_CDSERIE;

   SET @V_CDCONTADOR = 0;
   SET @V_NRCUPOMFIS = 'X';


/*--------------------------------------------------------------------*/
    DECLARE C_ITEMVENDA CURSOR FOR
      SELECT V.CDFILIAL,    V.CDLOJA,
             V.DTENTRVENDA, P.CDPRODUTO, P.NMPRODUTO,
             P.CDARVPROD, P.CDPRODESTO,
             T.NRMD5ARQTXT,V.NRCUPOMFIS,V.NRECFCUPOMVE,V.NRSERIEIMPVND,V.DSMODELOECFVE,V.DSMARCAECFVE,
             (I.VRUNITVEND + ISNULL(I.VRUNITVENDCL,0)) AS VRUNITVEND,
             SUM(I.QTPRODVEND) AS QTPRODVEND,
             ISNULL(SUM(I.VRDESITVEND),0) AS VRDESITVEND,
             SUM((I.QTPRODVEND * (I.VRUNITVEND + ISNULL(I.VRUNITVENDCL,0))) - ISNULL(I.VRDESITVEND,0)) AS VRTOTAITEM
      FROM VENDA V, ITEMVENDA I, PRODUTO P, TURCAIXA T
      WHERE (V.CDFILIAL     = @P_CDFILIAL)       AND
            (V.CDLOJA       = @P_CDLOJA)         AND
            (V.CDFILIAL     = I.CDFILIAL)       AND
            (V.CDCAIXA      = I.CDCAIXA)        AND
            (V.NRSEQVENDA   = I.NRSEQVENDA)     AND
            (V.CDFILIALTUR  = T.CDFILIAL  )     AND
            (V.CDCAIXATUR   = T.CDCAIXA   )     AND
            (V.DTABERTUR    = T.DTABERCAIX)     AND
            (V.IDSITUVENDA  = 'O')              AND
            (I.CDPRODUTO    = P.CDPRODUTO)      AND
            (I.NRLANCTONF   IS NULL)            AND
            (V.DTENTRVENDA BETWEEN @P_DTINICIAL  AND @P_DTFINAL) AND
            ((CHARINDEX(V.CDCAIXA, @P_CDCAIXA) > 0)  OR (@P_CDCAIXA IS NULL)) AND
            ((@P_LISTAVENDA IS NULL) OR (CHARINDEX(V.CDFILIAL+V.CDCAIXA+V.NRSEQVENDA, @P_LISTAVENDA) > 0)) AND
            ((CHARINDEX(I.CDPRODUTO, @P_CDPRODUTO) > 0) OR (@P_CDPRODUTO IS NULL))
      GROUP BY V.CDFILIAL,   V.CDLOJA,     V.DTENTRVENDA,
               P.CDPRODUTO,  P.NMPRODUTO,  P.CDARVPROD,
               P.CDPRODESTO, T.NRMD5ARQTXT,V.NRCUPOMFIS,
               V.NRECFCUPOMVE,V.NRSERIEIMPVND,V.DSMODELOECFVE,
               V.DSMARCAECFVE, I.VRUNITVEND, I.VRUNITVENDCL;
/*----------------------------------------------------------------------------------------*/
   OPEN C_ITEMVENDA;

   FETCH NEXT FROM C_ITEMVENDA INTO @C_CDFILIAL, @C_CDLOJA, @C_DTENTRVENDA,
                                    @C_CDPRODUTO, @C_NMPRODUTO, @C_CDARVPROD,
                                    @C_CDPRODESTO, @C_NRMD5ARQTXT, @C_NRCUPOMFIS,
                                    @C_NRECFCUPOMVE, @C_NRSERIEIMPVND, @C_DSMODELOECFVE,
                                    @C_DSMARCAECFVE, @C_VRUNITVEND, @C_QTPRODVEND,
                                    @C_VRDESITVEND, @C_VRTOTAITEM;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_CDCONTADOR = 0 BEGIN
         SET @V_CDCONTADOR = 1;

         IF @P_DTSAIDA IS NULL BEGIN
            SET @V_DTSAIDA = @C_DTENTRVENDA;
         END
         ELSE BEGIN
            SET @V_DTSAIDA = @P_DTSAIDA;
         END;

         EXEC GERA_NOTAFISCAL_CORPO @P_CDFILIPROC, @P_CDFILIAL, @V_CDEMPRESA,
                                    @P_CDTIPOOPER, @P_CDSERIE, @P_CDCLIENTE,
                                    @V_DTSAIDA, 'PDV', 'S', NULL, NULL ,NULL,
				    NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				    NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				    NULL, NULL, @V_NRLANCTONF OUTPUT, @V_NRLANCESTQ OUTPUT;

         --PREENCHENDO INFORMAES DO FISCO
         SELECT @V_NRDADOFISCO = MAX(NRDADOFISCO)
           FROM DADOSFISCO
          WHERE (CDFILIAL   = @P_CDFILIAL)
            AND (NRLANCTONF = @V_NRLANCTONF);

         IF (@V_NRDADOFISCO IS NULL) BEGIN
            SET @V_NRDADOFISCO = '001';
         END
         ELSE BEGIN
            SET @V_NRDADOFISCO = RIGHT(REPLICATE('0', 3) + RTRIM(CONVERT(VARCHAR, (CONVERT(INT, @V_NRDADOFISCO) + 1))), 3);
         END;

         INSERT INTO DADOSFISCO
            (CDFILIAL, NRLANCTONF, NRDADOFISCO, CDDADOFISCO, DSDADOFISCO)
         VALUES
            (@P_CDFILIPROC, @V_NRLANCTONF, @V_NRDADOFISCO, 'CODIGO MD5', @C_NRMD5ARQTXT);

         /*Atualiza os dados do cliente da nota fiscal*/
         SELECT @V_DADOSNF = COUNT(*)
         FROM DADOSNF
         WHERE (CDFILIAL   = @P_CDFILIPROC) AND
               (NRLANCTONF = @V_NRLANCTONF);

         IF @V_DADOSNF = 0 BEGIN
            INSERT INTO DADOSNF
              (CDFILIAL, NRLANCTONF, NRINSJUDESNF, NMRAZSODESNF, IDTPIJUDESNF,
               DSENDEDESTNF, NMBAIRDESTNF, CDPAIS, SGESTADO, CDMUNICIPIO,
               NRMD5ARQTXTNF, NRCOOCUPOMNF, NRECFCUPOMNF, NRSERIEIMPNF, DSMODELOECFNF,
               DSMARCAECFNF, NRINSESTDESNF)
            VALUES
               (@P_CDFILIPROC, @V_NRLANCTONF, @P_NRINSJUDESNF, @P_NMRAZSODESNF, @P_IDTPIJUDESNF,
                @P_DSENDEDESTNF, @P_NMBAIRDESTNF, @P_CDPAIS, @P_SGESTADO, @P_CDMUNICIPIO,
                @C_NRMD5ARQTXT, @C_NRCUPOMFIS, @C_NRECFCUPOMVE, @C_NRSERIEIMPVND, @C_DSMODELOECFVE,
                @C_DSMARCAECFVE, @P_NRINSESTDESNF);
         END;

      END;

      IF (@V_CDCONTADOR > @V_NRMAXITNF) AND (@V_IDCONMAXITEM = 'S') BEGIN
         SET @V_CDCONTADOR = 1;

         /*Atualizao de Estoque*/
         EXEC GERA_NOTAFISCAL_FECHAMENTO @P_CDFILIPROC, @V_NRLANCTONF, @V_DATE,
                                    @V_NRLANCESTQ, 'S';
         UPDATE NOTAFISCAL
         SET    CDOPERGERA = @P_CDOPERADOR
         WHERE (CDFILIAL   = @P_CDFILIPROC) AND
               (NRLANCTONF = @V_NRLANCTONF);

         EXEC ATUALIZA_IDEVOLESTOQ @P_CDFILIPROC, @V_NRLANCESTQ;

         IF @P_DTSAIDA IS NULL BEGIN
            SET @V_DTSAIDA = @C_DTENTRVENDA;
         END
         ELSE BEGIN
            SET @V_DTSAIDA = @P_DTSAIDA;
         END;
         EXEC GERA_NOTAFISCAL_CORPO @P_CDFILIPROC, @P_CDFILIAL, @V_CDEMPRESA,
                                    @P_CDTIPOOPER, @P_CDSERIE, @P_CDCLIENTE,
                                    @V_DTSAIDA, 'PDV', 'S', NULL, NULL ,NULL,
				    NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				    NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				    NULL, NULL, @V_NRLANCTONF OUTPUT, @V_NRLANCESTQ OUTPUT;

         --PREENCHENDO INFORMAES DO FISCO
         SELECT @V_NRDADOFISCO = MAX(NRDADOFISCO)
           FROM DADOSFISCO
          WHERE (CDFILIAL   = @P_CDFILIAL)
            AND (NRLANCTONF = @V_NRLANCTONF);

         IF (@V_NRDADOFISCO IS NULL) BEGIN
            SET @V_NRDADOFISCO = '001';
         END
         ELSE BEGIN
            SET @V_NRDADOFISCO = RIGHT(REPLICATE('0', 3) + RTRIM(CONVERT(VARCHAR, (CONVERT(INT, @V_NRDADOFISCO) + 1))), 3);
         END;

         INSERT INTO DADOSFISCO
            (CDFILIAL, NRLANCTONF, NRDADOFISCO, CDDADOFISCO, DSDADOFISCO)
         VALUES
            (@P_CDFILIPROC, @V_NRLANCTONF, @V_NRDADOFISCO, 'CODIGO MD5', @C_NRMD5ARQTXT);

         /*Atualiza os dados do cliente da nota fiscal*/
         SELECT @V_DADOSNF = COUNT(*)
         FROM DADOSNF
         WHERE (CDFILIAL   = @P_CDFILIPROC) AND
               (NRLANCTONF = @V_NRLANCTONF);

         IF @V_DADOSNF = 0 BEGIN
            INSERT INTO DADOSNF
              (CDFILIAL, NRLANCTONF, NRINSJUDESNF, NMRAZSODESNF, IDTPIJUDESNF,
               DSENDEDESTNF, NMBAIRDESTNF, CDPAIS, SGESTADO, CDMUNICIPIO,
               NRMD5ARQTXTNF, NRCOOCUPOMNF, NRECFCUPOMNF, NRSERIEIMPNF, DSMODELOECFNF,
               DSMARCAECFNF, NRINSESTDESNF)
            VALUES
               (@P_CDFILIPROC, @V_NRLANCTONF, @P_NRINSJUDESNF, @P_NMRAZSODESNF, @P_IDTPIJUDESNF,
                @P_DSENDEDESTNF, @P_NMBAIRDESTNF, @P_CDPAIS, @P_SGESTADO, @P_CDMUNICIPIO,
                @C_NRMD5ARQTXT, @C_NRCUPOMFIS, @C_NRECFCUPOMVE, @C_NRSERIEIMPVND, @C_DSMODELOECFVE,
                @C_DSMARCAECFVE, @P_NRINSESTDESNF);
         END;

      END;

      SELECT @V_CDALMOXARIFE = MAX(CDALMOXARIFE),
             @V_CDLOCALESTOQ = MAX(CDLOCALESTOQ)
      FROM LOJA
      WHERE CDFILIAL = @P_CDFILIAL AND
            CDLOJA   = @C_CDLOJA;

      EXEC GERA_NOTAFISCAL_PRODUTO @P_CDFILIPROC, @V_NRLANCTONF, @C_CDPRODUTO,
                                   @C_CDARVPROD, @C_NMPRODUTO,
                                   @C_QTPRODVEND, @C_VRUNITVEND, @C_VRDESITVEND,
                                   NULL, NULL, NULL, NULL, NULL, NULL, @V_CDALMOXARIFE, @V_CDLOCALESTOQ;


      EXEC UPDATE_ITEM_VENDA @P_CDFILIAL, @P_CDLOJA, @P_DTINICIAL, @P_DTFINAL, @P_CDCAIXA, @P_LISTAVENDA, @P_CDPRODUTO, @P_CDFILIPROC,
                             @P_DSMENSAGEM, @V_NRLANCTONF, @V_CDCONTADOR;



      SET @V_CDCONTADOR = @V_CDCONTADOR + 1;
   END;
   CLOSE C_ITEMVENDA;
   DEALLOCATE C_ITEMVENDA;


   IF (@V_CDCONTADOR > 0) BEGIN
      SET @V_CDCONTADOR = 1;

      /*Atualizao de Estoque*/
      EXEC GERA_NOTAFISCAL_FECHAMENTO @P_CDFILIPROC, @V_NRLANCTONF, @V_DATE,
                                      @V_NRLANCESTQ, 'S';
      UPDATE NOTAFISCAL
      SET    CDOPERGERA = @P_CDOPERADOR
      WHERE (CDFILIAL   = @P_CDFILIPROC) AND
            (NRLANCTONF = @V_NRLANCTONF);

      EXEC ATUALIZA_IDEVOLESTOQ @P_CDFILIPROC, @V_NRLANCESTQ;
   END;
   SELECT @V_CDCONTADOR = COUNT(*)
   FROM SERIEENTR
   WHERE CDSERIEENTR = @P_CDSERIE;

   IF @V_CDCONTADOR = 0 BEGIN
      INSERT INTO SERIEENTR
         (CDSERIEENTR, DSSERIEENTR)
      VALUES
         (@P_CDSERIE, @P_CDSERIE);
   END;

   SET @V_CDCONTADOR = 0;
   SET @V_NRCUPOMFIS = 'X';

   DECLARE C_ITEMDEVOLUCAO CURSOR FOR
       SELECT V.CDFILIAL,    V.CDLOJA,
             V.DTENTRVENDA, P.CDPRODUTO, P.NMPRODUTO,
             P.CDARVPROD, P.CDPRODESTO,
             T.NRMD5ARQTXT,V.NRCUPOMFIS,V.NRECFCUPOMVE,V.NRSERIEIMPVND,V.DSMODELOECFVE,V.DSMARCAECFVE,
             (I.VRUNITVEND + ISNULL(I.VRUNITVENDCL,0)) AS VRUNITVEND,
             SUM(I.QTPRODVEND) AS QTPRODVEND,
             ISNULL(SUM(I.VRDESITVEND),0) AS VRDESITVEND,
             SUM((I.QTPRODVEND * (I.VRUNITVEND + ISNULL(I.VRUNITVENDCL,0))) - ISNULL(I.VRDESITVEND,0)) AS VRTOTAITEM
      FROM VENDA V, ITEMVENDA I, PRODUTO P, TURCAIXA T
      WHERE (V.CDFILIAL     = @P_CDFILIAL)       AND
            (V.CDLOJA       = @P_CDLOJA)         AND
            (V.CDFILIAL     = I.CDFILIAL)       AND
            (V.CDCAIXA      = I.CDCAIXA)        AND
            (V.NRSEQVENDA   = I.NRSEQVENDA)     AND
            (V.CDFILIALTUR  = T.CDFILIAL  )     AND
            (V.CDCAIXATUR   = T.CDCAIXA   )     AND
            (V.DTABERTUR    = T.DTABERCAIX)     AND
            (V.IDSITUVENDA  = 'D')              AND
            (I.CDPRODUTO    = P.CDPRODUTO)      AND
            (I.NRLANCTONF   IS NULL)            AND
            (V.DTENTRVENDA BETWEEN @P_DTINICIAL  AND @P_DTFINAL) AND
            ((CHARINDEX(V.CDCAIXA, @P_CDCAIXA) > 0)  OR (@P_CDCAIXA IS NULL)) AND
            ((@P_LISTAVENDA IS NULL) OR (CHARINDEX(V.CDFILIAL+V.CDCAIXA+V.NRSEQVENDA, @P_LISTAVENDA) > 0)) AND
            ((CHARINDEX(I.CDPRODUTO, @P_CDPRODUTO) > 0) OR (@P_CDPRODUTO IS NULL))
      GROUP BY V.CDFILIAL,   V.CDLOJA,     V.DTENTRVENDA,
               P.CDPRODUTO,  P.NMPRODUTO,  P.CDARVPROD,
               P.CDPRODESTO, T.NRMD5ARQTXT,V.NRCUPOMFIS,
               V.NRECFCUPOMVE, V.NRSERIEIMPVND, V.DSMODELOECFVE,
               V.DSMARCAECFVE, I.VRUNITVEND, I.VRUNITVENDCL;

   OPEN C_ITEMDEVOLUCAO;
   FETCH NEXT FROM C_ITEMDEVOLUCAO INTO @C_CDFILIAL,  @C_CDLOJA, @C_DTENTRVENDA,
                                        @C_CDPRODUTO, @C_NMPRODUTO, @C_CDARVPROD,
                                        @C_CDPRODESTO, @C_NRMD5ARQTXT, @C_NRCUPOMFIS,
                                        @C_NRECFCUPOMVE, @C_NRSERIEIMPVND, @C_DSMODELOECFVE,
                                        @C_DSMARCAECFVE, @C_VRUNITVEND, @C_QTPRODVEND,
                                        @C_VRDESITVEND, @C_VRTOTAITEM;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_CDCONTADOR = 0 BEGIN

         SET @V_CDCONTADOR = 1;

         IF @P_DTSAIDA IS NULL BEGIN
            SET @V_DTSAIDA = @C_DTENTRVENDA;
         END
         ELSE BEGIN
            SET @V_DTSAIDA = @P_DTSAIDA;
         END;
         EXEC GERA_NOTAFISCAL_CORPO_ENTRADA @P_CDFILIPROC, @P_CDFILIAL, @V_CDEMPRESA,
                                       '13', @P_CDSERIE, @P_CDCLIENTE,
                                       @V_DTSAIDA, 'PDV', 0, @V_NRLANCTONF,
                                       @V_NRLANCESTQ, 'S';

         --PREENCHENDO INFORMAES DO FISCO
         SELECT @V_NRDADOFISCO = MAX(NRDADOFISCO)
           FROM DADOSFISCO
          WHERE (CDFILIAL   = @P_CDFILIAL)
            AND (NRLANCTONF = @V_NRLANCTONF);

         IF (@V_NRDADOFISCO IS NULL) BEGIN
            SET @V_NRDADOFISCO = '001';
         END
         ELSE BEGIN
            SET @V_NRDADOFISCO = RIGHT(REPLICATE('0', 3) + RTRIM(CONVERT(VARCHAR, (CONVERT(INT, @V_NRDADOFISCO) + 1))), 3);
         END;

         INSERT INTO DADOSFISCO
            (CDFILIAL, NRLANCTONF, NRDADOFISCO, CDDADOFISCO, DSDADOFISCO)
         VALUES
            (@P_CDFILIPROC, @V_NRLANCTONF, @V_NRDADOFISCO, 'CODIGO MD5', @C_NRMD5ARQTXT);

         /*Atualiza os dados do cliente da nota fiscal*/
         SELECT @V_DADOSNF = COUNT(*)
         FROM DADOSNF
         WHERE (CDFILIAL   = @P_CDFILIPROC) AND
               (NRLANCTONF = @V_NRLANCTONF);

         IF @V_DADOSNF = 0 BEGIN
            INSERT INTO DADOSNF
              (CDFILIAL, NRLANCTONF, NRINSJUDESNF, NMRAZSODESNF, IDTPIJUDESNF,
               DSENDEDESTNF, NMBAIRDESTNF, CDPAIS, SGESTADO, CDMUNICIPIO,
               NRMD5ARQTXTNF, NRCOOCUPOMNF, NRECFCUPOMNF, NRSERIEIMPNF, DSMODELOECFNF,
               DSMARCAECFNF, NRINSESTDESNF)
            VALUES
               (@P_CDFILIPROC, @V_NRLANCTONF, @P_NRINSJUDESNF, @P_NMRAZSODESNF, @P_IDTPIJUDESNF,
                @P_DSENDEDESTNF, @P_NMBAIRDESTNF, @P_CDPAIS, @P_SGESTADO, @P_CDMUNICIPIO,
                @C_NRMD5ARQTXT, @C_NRCUPOMFIS, @C_NRECFCUPOMVE, @C_NRSERIEIMPVND, @C_DSMODELOECFVE,
                @C_DSMARCAECFVE, @P_NRINSESTDESNF);
         END;

      END;

      IF (@V_CDCONTADOR > @V_NRMAXITNF) AND (@V_IDCONMAXITEM = 'S') BEGIN
         SET @V_CDCONTADOR = 1;

         /*Atualizao de Estoque*/
         EXEC GERA_FECHAMENTO_NFENTRADA @P_CDFILIPROC, @V_NRLANCTONF, @V_DATE,
                                   @V_NRLANCESTQ, 'S';
         EXEC ATUALIZA_IDEVOLESTOQ @P_CDFILIPROC, @V_NRLANCESTQ;


         IF @P_DTSAIDA IS NULL BEGIN
            SET @V_DTSAIDA = @C_DTENTRVENDA;
         END
         ELSE BEGIN
            SET @V_DTSAIDA = @P_DTSAIDA;
         END;

         EXEC GERA_NOTAFISCAL_CORPO_ENTRADA @P_CDFILIPROC, @P_CDFILIAL, @V_CDEMPRESA,
                                       '13', @P_CDSERIE, @P_CDCLIENTE,
                                       @V_DTSAIDA, 'PDV', 0, @V_NRLANCTONF,
                                       @V_NRLANCESTQ, 'S';

         --PREENCHENDO INFORMAES DO FISCO
         SELECT @V_NRDADOFISCO = MAX(NRDADOFISCO)
           FROM DADOSFISCO
          WHERE (CDFILIAL   = @P_CDFILIAL)
            AND (NRLANCTONF = @V_NRLANCTONF);

         IF (@V_NRDADOFISCO IS NULL) BEGIN
            SET @V_NRDADOFISCO = '001';
         END
         ELSE BEGIN
            SET @V_NRDADOFISCO = RIGHT(REPLICATE('0', 3) + RTRIM(CONVERT(VARCHAR, (CONVERT(INT, @V_NRDADOFISCO) + 1))), 3);
         END;

         INSERT INTO DADOSFISCO
            (CDFILIAL, NRLANCTONF, NRDADOFISCO, CDDADOFISCO, DSDADOFISCO)
         VALUES
            (@P_CDFILIPROC, @V_NRLANCTONF, @V_NRDADOFISCO, 'CODIGO MD5', @C_NRMD5ARQTXT);

         /*Atualiza os dados do cliente da nota fiscal*/
         SELECT @V_DADOSNF = COUNT(*)

         FROM DADOSNF
         WHERE (CDFILIAL   = @P_CDFILIPROC) AND
               (NRLANCTONF = @V_NRLANCTONF);

         IF @V_DADOSNF = 0 BEGIN
            INSERT INTO DADOSNF
              (CDFILIAL, NRLANCTONF, NRINSJUDESNF, NMRAZSODESNF, IDTPIJUDESNF,
               DSENDEDESTNF, NMBAIRDESTNF, CDPAIS, SGESTADO, CDMUNICIPIO,
               NRMD5ARQTXTNF, NRCOOCUPOMNF, NRECFCUPOMNF, NRSERIEIMPNF, DSMODELOECFNF,
               DSMARCAECFNF, NRINSESTDESNF)
            VALUES
               (@P_CDFILIPROC, @V_NRLANCTONF, @P_NRINSJUDESNF, @P_NMRAZSODESNF, @P_IDTPIJUDESNF, 
                @P_DSENDEDESTNF, @P_NMBAIRDESTNF, @P_CDPAIS, @P_SGESTADO, @P_CDMUNICIPIO,
                @C_NRMD5ARQTXT, @C_NRCUPOMFIS, @C_NRECFCUPOMVE, @C_NRSERIEIMPVND, @C_DSMODELOECFVE,
                @C_DSMARCAECFVE, @P_NRINSESTDESNF);
         END;

      END;

      SELECT @V_CDALMOXARIFE = MAX(CDALMOXARIFE),
             @V_CDLOCALESTOQ = MAX(CDLOCALESTOQ)
      FROM LOJA
      WHERE CDFILIAL = @P_CDFILIAL AND
            CDLOJA   = @C_CDLOJA;

      EXEC GERA_NOTAFISCAL_PRODUTO @P_CDFILIPROC, @V_NRLANCTONF, @C_CDPRODUTO,
                              @C_CDARVPROD, @C_NMPRODUTO,
                              @C_QTPRODVEND, @C_VRUNITVEND, @C_VRDESITVEND,
                              NULL, NULL, NULL, NULL, NULL, NULL, @V_CDALMOXARIFE, @V_CDLOCALESTOQ;


      EXEC UPDATE_ITEM_VENDA @P_CDFILIAL, @P_CDLOJA, @P_DTINICIAL, @P_DTFINAL, @P_CDCAIXA, @P_LISTAVENDA, @P_CDPRODUTO, @P_CDFILIPROC,
                             @P_DSMENSAGEM, @V_NRLANCTONF, @V_CDCONTADOR;

      SET @V_CDCONTADOR = @V_CDCONTADOR + 1;

   END;

   CLOSE C_ITEMDEVOLUCAO;
   DEALLOCATE C_ITEMDEVOLUCAO;

   IF (@V_CDCONTADOR > 0) BEGIN
      SET @V_CDCONTADOR = 1;

      /*Atualizao de Estoque*/
      EXEC GERA_FECHAMENTO_NFENTRADA @P_CDFILIPROC, @V_NRLANCTONF, @V_DATE,
                                @V_NRLANCESTQ, 'S';
      EXEC ATUALIZA_IDEVOLESTOQ @P_CDFILIPROC, @V_NRLANCESTQ;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GERA_NOTAFISCAL_VENDA','5.70.xxx';
GO
