var Configuration;
var moment;
var setLocalVar;
var getLocalVar;
var Util;
var angular;
let messages = {
    errosApuracao: "Erros na Apuração",
    timeout: "Tempo limite de conexão excedido."
};
var dadosInconsistencia = {};
var nr_log_corte_ol;
var resultApuracao;
var adqParams = [];

function opl00900_listagem_de_corteController(General, Utilities, RestEngine, ScreenService, MessageService, templateManager, maskEngine, ZhUtil, ZHPromise){
    
    //Referencia a uma constante global onde a mesma armazena funções a serem usadas/aplicadas como terceiro parametro no serviço {MessageService}...
    /*global Constants*/

    //Inicia um novo filtro
    this.startScreen = function(widget) {
        widget.newRow();
        setTimeout( () => {
            ScreenService.showLoader();
            getLocalVar('CDFILIAL');
            this.adqParam();
            ScreenService.hideLoader();
        }, 1000);
        this.setFilterInitValues(widget);
    };
    
    //Busca parametros
    this.adqParam = function(){
        General.callRestEngine("opl_relatorios#/crud/adqParam", "FilterData", [
                {
                    'name': 'CDFILCENTCMP',
                    'operator': '=',
                    'value': getLocalVar('CDFILIAL')
                }
            ]).then(function(response) {
                adqParams = response.dataset.adqParam[0];
        }).catch(function(error) {
            ScreenService.showMessage(error.data.error);
        });
    };
    
    //Seta os filtros iniciais
    this.setFilterInitValues = function(widget){
	    widget.currentRow.L_PER_LEV_PREV_CONS = {};
	    widget.currentRow.L_PER_LEV_PREV_CONS.formattedStart = moment().format('L');
        widget.currentRow.L_PER_LEV_PREV_CONS.formattedEnd = moment().format('L');
	    widget.currentRow.L_PER_LEV_PREV_CONS.start = moment().format('L');
        widget.currentRow.L_PER_LEV_PREV_CONS.end = moment().format('L');
        
	    widget.currentRow.L_PER_LEV_AF = {};
	    widget.currentRow.L_PER_LEV_AF.formattedStart = moment().format('L');
        widget.currentRow.L_PER_LEV_AF.formattedEnd = moment().format('L');
	    widget.currentRow.L_PER_LEV_AF.start = moment().format('L');
        widget.currentRow.L_PER_LEV_AF.end = moment().format('L');
    };
    
    //Preenche o field de Unidades
    this.selectUnidades = function(widget) {
        widget.getField('L_FILIAL').dataSource.name = "opl_relatorios#/crud/opl00900_filial_regiao";
        widget.getField('L_FILIAL').dataSourceFilter = [
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": adqParams.CDFILIAL
            }
        ];
        widget.getField('L_FILIAL').reload();
        this.setNGeracaoNull(widget);
    };
    
    //Seta o field Unidades como vazio/nulo
    this.setUnidadesNull = function(widget){
        widget.getField('L_FILIAL').clearValue();
    };
    
    //Preenche o field Número Geração
    this.selectNGeracao = function(widget) {
        if(widget.currentRow.L_FILIAL) {
            var filial = widget.currentRow.CDFILIAL;
            widget.getField('NR_GERACAO').dataSource.name = "opl_relatorios#/crud/opl00900_nr_geracao";
            widget.getField('NR_GERACAO').dataSourceFilter = [
                {
                    "name": "P_CDFILIOPELOG",
                    "operator": "=",
                    "value": filial
                }
            ];
            widget.getField('NR_GERACAO').reload();
        } else {
            this.setNGeracaoNull(widget);
            this.setUnidadesNull(widget);
            MessageService.showMessageByCode("L_FILIAL_VAZIA");
        }
    };
    
    //Determina o field N.Geração como Null/Vazio
    this.setNGeracaoNull = function(widget) {
        widget.getField('NR_GERACAO').clearValue();
    };
    
    //Validação no field N.Geração
    this.verificaNGeracao = function(args) {
		var widget = args.owner.field.widget;
		var row = widget.currentRow;
		var filialIsSet = this.fieldIsSet(row.L_FILIAL);
        if(!filialIsSet) {
			widget.currentRow.NR_GERACAO = '';
			widget.currentRow.CDFILIAL = '';
			if(widget.name === "opl00900") {
                widget.getField('NR_GERACAO').readOnly = true;
                widget.getField('NR_GERACAO').readOnlyOnEdit = true;
                this.setNGeracaoNull(widget);
			}
        } else if(widget.name === "opl00900") {
            widget.getField('NR_GERACAO').readOnly = false;
            widget.getField('NR_GERACAO').readOnlyOnEdit = false;
            this.setNGeracaoNull(widget);
        }
    };

    //Verifica se o field foi setado
	this.fieldIsSet = function(fieldValue) {
		if (fieldValue) return true;
		else return false;
	};
	
	//Seta o field Produto Inicial
	this.filterProdIni = function(args) {
		var widget = args.owner.field.widget;
		var row = widget.currentRow;
		var prodIniIsSet = this.fieldIsSet(row.CDPRODINI);
		if(!prodIniIsSet) {
			widget.currentRow.NMPRODFIN = '';
			widget.currentRow.CDPRODFIN = '';
		}
        this.checkProductRange(args.owner.field);
	};
	
	//Seta o field Produto Final
	this.filterProdFin = function(args) {
		var widget = args.owner.field.widget;
		var row = widget.currentRow;
		var prodFinIsSet = this.fieldIsSet(row.CDPRODFIN);
		var prodIniIsSet = this.fieldIsSet(row.CDPRODINI);
		if (prodFinIsSet) {
			if (row.CDPRODINI > row.CDPRODFIN) {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
			}
		} 
		this.checkProductRange(args.owner.field);
	};
	
	//Validação dos fields Prod. Inicial e Final
	this.checkProductRange = function(field) {
	   var currentRow = field.widget.currentRow;
		if (currentRow.CDPRODINI && currentRow.CDPRODFIN) {
			var compproduto = (currentRow.CDPRODFIN) ? currentRow.CDPRODFIN.replace(/[\.\-]/g, '') : null;
			if (!this.comparaPratoProduto(currentRow.CDPRODINI, compproduto, getLocalVar('CDPICTPROD'))) {
				currentRow[field.outData[field.descriptionField]] = null;
				currentRow[field.outData[field.valueField]] = null;
                field.widget.getField('NMPRODINI').clearValue();
                field.widget.getField('NMPRODFIN').clearValue();
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
			}
		}
	};
	
	//Validação dos fields de Produtos
	this.comparaPratoProduto = function(pinicial, pfinal, mascara) {
        var mask = {
          type: "fix",
          params: {
              mask: mascara
          }
        };
        pinicial = Util.applyMask(pinicial, mask, maskEngine, ZhUtil).split('.');
        pfinal = Util.applyMask(pfinal, mask, maskEngine, ZhUtil).split('.');
        var nvinicial = pinicial.length;
        var nvfinal = pfinal.length;
        var resultado = true;
        if(nvinicial != nvfinal) {
            if(nvinicial > nvfinal) {
                resultado = false;
            }
        } else {
            var i = 0;
            do {
                if(pinicial[i] > pfinal[i]) {
                    resultado = false;
                }
                i++;
            }
            while (i<pinicial.length && resultado);
        }
        return resultado;
    };
    
    //Alteração dos fields do formulãrio de acordo com o field N.Geralção
    this.changeFieldsFromForm = function(widget) {
        if (widget.getField('NR_GERACAO').value().length >= 1) {
            //Clear values
            widget.getField('L_PER_LEV_PREV_CONS').clearValue();
            widget.getField('L_PER_LEV_AF').clearValue();
            widget.getField('L_COMPRADOR').clearValue();
            widget.getField('L_REGIAO').clearValue();
            widget.getField('NMPRODINI').clearValue();
            widget.getField('NMPRODFIN').clearValue();
            //Set ReadOnly fields
            widget.getField('L_PER_LEV_PREV_CONS').readOnly = true;
            widget.getField('L_PER_LEV_AF').readOnly = true;
            widget.getField('L_COMPRADOR').readOnly = true;
            widget.getField('L_REGIAO').readOnly = true;
            widget.getField('NMPRODINI').readOnly = true;
            widget.getField('NMPRODFIN').readOnly = true;
            //Delete validations of fields
            delete widget.getField('NMPRODINI').validations.required;
            delete widget.getField('NMPRODFIN').validations.required;
        } else {
            //Alter ReadOnly fields
            widget.getField('L_PER_LEV_PREV_CONS').readOnly = false;
            widget.getField('L_PER_LEV_AF').readOnly = false;
            widget.getField('L_COMPRADOR').readOnly = false;
            widget.getField('L_REGIAO').readOnly = false;
            widget.getField('NMPRODINI').readOnly = false;
            widget.getField('NMPRODFIN').readOnly = false;
            //Alter validations of fields
            widget.getField('NMPRODINI').validations.required = true;
            widget.getField('NMPRODFIN').validations.required = true;
            this.setFilterInitValues(widget);
        }
    };
    
    //Valida o formulário antes de gerar o relatõrio
    this.verificaRelatorio = function(widget) {
        var currentRow = widget.currentRow;
        if(widget.isValid()) {
            if(currentRow.L_PER_LEV_PREV_CONS !== "" && currentRow.L_PER_LEV_AF !== ""){
                var cons_start = currentRow.L_PER_LEV_PREV_CONS.start;
                var af_end = currentRow.L_PER_LEV_AF.end;
                if (moment(cons_start, "DD/MM/YYYY") <= moment(af_end, "DD/MM/YYYY")){
                    MessageService.showMessageByCode("DT_INICIAL_PREVISAO_CONSUMO_MENOR_DT_FINAL_AF", null, Constants.errorMessage);
                    return;
                } else {
                    cons_start = moment(cons_start, "DD/MM/YYYY");
                    af_end = moment(af_end, "DD/MM/YYYY");
                    if (moment(cons_start).diff(af_end, "days") > 1){
                        MessageService.showMessageByCode("PERIODO_NAO_ATENTIDO_ENTRE_DT_FINAL_AF_E_DT_INICIAL_PREVISAO_CONSUMO", null, Constants.alertMessage);
                    }
                    var reportName = currentRow.REPORT_NAME.split('.')[0];
                    General.openReportPopup(widget, this.abreRelatorio, [widget, currentRow, reportName]);      
                }    
            }
        }
    };
    
    //Verifica o formulário e valida o COMPRADOR
    this.verificaFormForCalculo = function(widget) {
        if(widget.isValid()) {
            this.openLoginValidation(widget);
        }
    };
    
    //Abre o relatório gerado
    this.abreRelatorio = function(widget, currentRow, reportName) {
        var row = angular.copy(currentRow);
        row.P_CDFILIALOL = row.CDFILIAL;
        if (row.NR_GERACAO) {
            row.P_NRLOGCORTEOL = row.NR_GERACAO;
        } else {
            row.P_NRLOGCORTEOL = '';
        }
        row.P_DTINICIAL = row.L_PER_LEV_PREV_CONS.start;
        row.P_DTFINAL = row.L_PER_LEV_PREV_CONS.end;
        row.P_DTINICIALAF = row.L_PER_LEV_AF.start;
        row.P_DTFINALAF = row.L_PER_LEV_AF.end;
        row.P_CDREGIAO = row.L_REGIAO ? Array.isArray(row.L_REGIAO) && row.L_REGIAO.length > 0 ? row.L_REGIAO.join('_') : 'T' : 'T';
        row.P_CDOPERADOR = row.L_COMPRADOR ? Array.isArray(row.L_COMPRADOR) && row.L_COMPRADOR.length > 0 ? row.L_COMPRADOR.join('_') : 'T' : 'T';
        row.P_CDPRODINIC = row.CDPRODINI;
        if(row.CDPRODFIN) {
            let concatString = row.CDPRODFIN.concat('ZZZZZZZZZZZZZZZZZZZZ');
            row.P_CDPRODFIN = concatString.substring(0, 20);
        } else {
            row.P_CDPRODFIN = 'ZZZZZZZZZZZZZZZZZZZZ';
        }
        row.P_GERACMP = 'N';
        row.P_ANALITICO = row.ANALITICO;
        row.STRATEGY = row.REPORT_NAME.split('.')[1];
        row.NRORG = getLocalVar('NRORG');
        row.reportLabel = '';
        General.openReport("opl_relatorios#/opl00900_relatorio", reportName, row).then(success => {}).catch(error => {
            MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
        });
    };
    
    //Abre o form para Login
    this.openLoginValidation = function(widget) {
        var DTINICIAL = widget.currentRow.L_PER_LEV_PREV_CONS.start;
        var DTFINAL = widget.currentRow.L_PER_LEV_PREV_CONS.end;
        var DTINICIALAF = widget.currentRow.L_PER_LEV_AF.start;
        var DTFINALAF = widget.currentRow.L_PER_LEV_AF.end;
        var NMOPERADOR = "";
        if(DTINICIAL != "" && DTFINAL != "" && widget.currentRow.L_COMPRADOR != "" && widget.currentRow.L_COMPRADOR !== `T` || DTINICIALAF != "" && DTFINALAF != "" && widget.currentRow.L_COMPRADOR != "" && widget.currentRow.L_COMPRADOR !== `T`) {
            if (widget.currentRow.L_COMPRADOR.length === 1) {
                General.callRestEngine("opl_relatorios#/compValidationListagemCorte", "Row", {
                    "CDCOMPRADOR": widget.currentRow.L_COMPRADOR[0],
                    "CDOPERADOR": getLocalVar('CDOPERADOR'),
                    "CDCENTCMP": adqParams.CDFILIAL
                }).then(function(response) {
                    if (response.dataset.passwordAut.PARAM === 'S') {
                        //Busca o nome do comprador e seta um nova string para o field NMOPERADOR
                        widget.getField("L_COMPRADOR").dataSource.data.forEach(function(item){
                            if(item.CDOPERADOR === widget.currentRow.L_COMPRADOR[0]){
                                NMOPERADOR = item.CDOPERADOR + ' | ' + item.NMOPERADOR;
                            }
                        });
                        widget.container.getWidget('LOGIN').currentRow.CDCOMPRADOR = widget.currentRow.L_COMPRADOR[0];
                        widget.container.getWidget('LOGIN').currentRow.CDOPERADOR = getLocalVar('CDOPERADOR');
                        widget.container.getWidget('LOGIN').getField('NMCOMPRADOR').setValue(NMOPERADOR);
                        ScreenService.openPopup(widget.container.getWidget('LOGIN'));
                    } else if(response.dataset.passwordAut.PARAM === 'N') {
                        MessageService.showMessageByCode("OPERADOR_NAO_AUTORIZADO_APURACAO_COMPRADOR", null, Constants.errorMessage);
                    }
                }).catch(function(error) {
                    ScreenService.showMessage(error.data ? error.data.error : messages.timeout, 'error', 'error');
                    widget.currentRow.CDCOMPRADOR = "";
                });
            } else {
                MessageService.showMessageByCode("INFORMAR_APENAS_UM_COMPRADOR", null, Constants.errorMessage);
            }
        } else {
            if(widget.currentRow.L_COMPRADOR == "" || widget.currentRow.L_COMPRADOR.length === 0 || widget.currentRow.L_COMPRADOR === `T`){
                MessageService.showMessageByCode("INFORMAR_UM_COMPRADOR", null, Constants.alertMessage);
            } else if (DTINICIAL == "" && DTFINAL == "" || DTINICIALAF == "" && DTFINALAF == "") {
                MessageService.showMessageByCode("INFORMAR_PERIODO_LEVANTAMENTO", null, Constants.alertMessage);
            }
        }
    };

    //Valida o Login
    this.loginValidation = function(widget) {
        if(!Util.isEmptyOrBlank(widget.currentRow.PASSWORD)){
            General.callRestEngine("opl_relatorios#/passwordValidation", "Row", widget.currentRow).then(function(response) {
                widget.currentRow = {};
                ScreenService.closePopup();
                //Chama a procedure 
                procedureCalcular();
            }).catch(function(error) {
                if(error.data.error === "Senha inválida"){
                    MessageService.showMessageByCode("INVALID_PASSWORD");
                } else {
                    ScreenService.showMessage(error.data.error);
                }
                widget.currentRow.PASSWORD = "";
            });
        } else {
            MessageService.showMessageByCode("INFORMAR_SENHA_LOGIN", null, Constants.alertMessage);
        }
    };
    
    //Executa procedure de Calcular
    var procedureCalcular = function() {
        var widget = templateManager.container.getWidget('opl00900');
        var dataCONS = widget.currentRow.L_PER_LEV_PREV_CONS;
        var dataAF = widget.currentRow.L_PER_LEV_AF;
        //Valida a data inicial de Consumo
        if(widget.currentRow.L_PER_LEV_PREV_CONS.formattedStart === '__/__/____'){
            dataCONS.start = '';
        }
        //Valida a data final de Consumo
        if(widget.currentRow.L_PER_LEV_PREV_CONS.formattedEnd === '__/__/____'){
            dataCONS.end = '';
        }
        //Valida a data inicial de AF
        if(widget.currentRow.L_PER_LEV_AF.formattedStart === '__/__/____'){
            dataAF.start = '';
        }
        //Valida a data final de AF
        if(widget.currentRow.L_PER_LEV_AF.formattedEnd === '__/__/____'){
            dataAF.end = '';
        }
        ScreenService.showLoader();
        General.callRestEngine("opl_relatorios#/getGeraCorteOL", "Row", {
            "P_CDCENTCMP": adqParams.CDFILIAL,
            "P_CDFILIOPELOG": widget.currentRow.CDFILIAL,
            "P_CDFILLANC": getLocalVar('CDFILIAL'),
            "P_CDOPERLANC": getLocalVar('CDOPERADOR'),
            "P_DTINICIAL": dataCONS,
            "P_DTFINAL": dataCONS,
            "P_DTINICIALAF": dataAF,
            "P_DTFINALAF": dataAF,
            "P_TIPOCONSULTA": '',
            "P_COMPRADOR": widget.currentRow.L_COMPRADOR[0],
            "P_CDREGIAO": widget.currentRow.L_REGIAO ? Array.isArray(widget.currentRow) && widget.currentRow.L_REGIAO.length > 0 ? widget.currentRow.L_REGIAO.join('_') : 'T' : 'T',
            "P_CDPRODINIC": widget.currentRow.CDPRODINI,
            "P_CDPRODFIN": (widget.currentRow.CDPRODFIN + "ZZZZZZZZZZZZZZZZZZZZ").substr(0, 20),
            "P_DTPROCESSA": getLocalVar('DTPROCESSA')
        }).then(function(response) {
            //Se o response for diferente de "NN"
            if(response.dataset.result[0] !== "NN"){
                //Armazena o P_NRSEQAPUR e P_ROWSAFFECT
                nr_log_corte_ol = response.dataset.result[0][1].P_NRSEQAPUR;
                response = response.dataset.result[0][0].P_ROWSAFFECT;
                //Cria um variavel Local
                setLocalVar('paramNRSEQAPUR', nr_log_corte_ol);
            } else {
                //Armazena o response
                response = response.dataset.result[0];
            }
            //Se foi response retornado "NN"
            if (response === "NN") {
                ZHPromise.all(MessageService.showMessageByCode("NAO_HA_DADOS_APURACAO_EFETIVACAO_OL", null, Constants.errorMessage)).then(function(){});
            } else {
                MessageService.confirmMessageByCode("QUESTION_VERIFICAR_INCONSISTENCIA_APURACAO_EFETIVACAO_OL", null, Constants.confirmationMessage).then(function(success) {
                    //Armazena os dados na aray de inconsistencia
                    dadosInconsistencia.P_CDFILIALOL = widget.currentRow.CDFILIAL;
                    dadosInconsistencia.P_CDOPERADOR = widget.currentRow.L_COMPRADOR[0];
                    dadosInconsistencia.P_CDFILCENTCMP = '';
                    dadosInconsistencia.P_NRAPURPREC = '';
                    if(widget.currentRow.L_PER_LEV_PREV_CONS.start !== ''){
                        dadosInconsistencia.P_DTINICIAL = widget.currentRow.L_PER_LEV_PREV_CONS.start;
                    } else if (widget.currentRow.L_PER_LEV_AF.start !== ''){
                        dadosInconsistencia.P_DTINICIAL = widget.currentRow.L_PER_LEV_AF.start;
                    } else {
                        dadosInconsistencia.P_DTINICIAL = '';
                    }
                    if(widget.currentRow.L_PER_LEV_PREV_CONS.end !== ''){
                        dadosInconsistencia.P_DTFINAL = widget.currentRow.L_PER_LEV_PREV_CONS.end;
                    } else if (widget.currentRow.L_PER_LEV_AF.end !== ''){
                        dadosInconsistencia.P_DTFINAL = widget.currentRow.L_PER_LEV_AF.end;
                    } else {
                        dadosInconsistencia.P_DTFINAL = '';
                    }
                    dadosInconsistencia.P_NRLOGCORTEOL = response.substr(1, 9);
                    widget.container.getWidget('opl00900').reload();
                    widget.container.getWidget('gridInconsistencia').reload();
                    ScreenService.openPopup(widget.container.getWidget('gridInconsistencia'));
                }, function(error) {
                    ScreenService.errorNotification(error, 'ERROR');
                });
                //Armazena o resultado da apuracao
                resultApuracao = response.substr(12,1);
            }
            //Se tem response OU se o result é maior que 12(em caracters) e a posição 12 da string é = "N"
            if (!response || response.length >= 13 && response.substr(11,1) === "N") {
                ZHPromise.all(MessageService.showMessageByCode("NAO_HA_DADOS_APURACAO_EFETIVACAO_OL", null, Constants.errorMessage)).then(function(){
                    //Abre a tela de apuração/Efet... OL
                    openWindowApuracaoEfetivacaoOL();
                });
            }
        }).catch(function(error) {
            MessageService.showMessageByCode("ERRO_AO_CALCULAR", null, Constants.errorMessage);
        });
        ScreenService.hideLoader();
    };
    
    //Monta o filtro do datasouce do grid de insconsistencia
    this.setDataSourceFilter = function(){
        var widgetInconsistencia = templateManager.container.getWidget('gridInconsistencia');
        var widgetOpl00900 = templateManager.container.getWidget('opl00900');
        widgetInconsistencia.dataSourceFilter = [
	        {
	            "name": "P_CDFILIALOL",
		        "operator": "=",
		        "value": dadosInconsistencia.P_CDFILIALOL
		    },
		    {
		        "name": "P_CDOPERADOR",
		        "operator": "=",
		        "value": dadosInconsistencia.P_CDOPERADOR
		    },
		    {
		        "name": "P_CDFILCENTCMP",
		        "operator": "=",
		        "value": dadosInconsistencia.P_CDFILCENTCMP
		    },
		    {
		        "name": "P_NRAPURPREC",
		        "operator": "=",
		        "value": dadosInconsistencia.P_NRAPURPREC
		    },
		    {
		        "name": "P_DTINICIAL",
		        "operator": "=",
		        "value": dadosInconsistencia.P_DTINICIAL
		    },
		    {
		        "name": "P_DTFINAL",
		        "operator": "=",
		        "value": dadosInconsistencia.P_DTFINAL
		    },
		    {
		        "name": "P_NRLOGCORTEOL",
		        "operator": "=",
		        "value": dadosInconsistencia.P_NRLOGCORTEOL
		    }
	    ];
	    ScreenService.showLoader();
	    widgetInconsistencia.reload();
	    widgetOpl00900.reload();
	    ScreenService.hideLoader();
    };
    
    //Seta a label do popup Relatório de Insonsistência
    this.setLabel = function(){
        var widgetOpl00900 = templateManager.container.getWidget('opl00900');
        var widgetInconsistencia = templateManager.container.getWidget('gridInconsistencia');
        setTimeout(() => {
            ScreenService.showLoader();
	        var data = widgetInconsistencia.groupedData[0];
	        MessageService.getMessageByCode('LABEL_POPUP_INSCONSISTENCIA').then(function(response){
                var label = response;
                //Replace das datas no label
                label = label.replace("__DT_CONS_INI__", widgetOpl00900.currentRow.L_PER_LEV_PREV_CONS.formattedStart);
    	        label = label.replace("__DT_CONS_FIN__", widgetOpl00900.currentRow.L_PER_LEV_PREV_CONS.formattedEnd);
    	        label = label.replace("__DT_AF_INI__", widgetOpl00900.currentRow.L_PER_LEV_AF.formattedStart);
    	        label = label.replace("__DT_AF_FIN__", widgetOpl00900.currentRow.L_PER_LEV_AF.formattedEnd);
                //Se foram encontrados dados, setam os seguitnes parametros    	        
                if(data !== undefined) {
                    if(data.CDFILIALOL){
                       label = label.replace("__CDFILIALOL__", data.CDFILIALOL);  
                    }
                    if(data.NMFILIALOL){
                       label = label.replace("__NMFILIALOL__", data.NMFILIALOL);  
                    }
                    if(data.CDOPERADOR){
                       label = label.replace("__CDOPERADOR__", data.CDOPERADOR);  
                    }
                    if(data.NMOPERADOR){
                       label = label.replace("__NMOPERADOR__", data.NMOPERADOR);  
                    }
                } else {
                    label = label.replace("__CDFILIALOL__", '');  
                    label = label.replace("__NMFILIALOL__", '');  
                    label = label.replace("__CDOPERADOR__", '');  
                    label = label.replace("__NMOPERADOR__", '');  
                }
                widgetInconsistencia.label = label;
                widgetInconsistencia.redraw();
                ScreenService.hideLoader();
            });
        }, 600);
    };
    
    //Chama a função que abre a tela de apuração;efetivação
    this.callFunctionOpenWindowApuracaoEfetivacaoOL = function() {
        openWindowApuracaoEfetivacaoOL('relatorio_inconsistencia_confimado');  
    };
    
    //Abre a tela de Apuração Efetivação do OL
    var openWindowApuracaoEfetivacaoOL = function (relatorio_inconsistencia_confimado){
        //Armazena o NMOPERADOR
        var NMOPERADOR = ""; 
        //Se o resultado da apuração for igual "N"
        if (resultApuracao === "N") {
            ZHPromise.all(MessageService.showMessageByCode("NAO_HA_DADOS_VERIFICAO_INCONSISTENCIA", null, Constants.errorMessage)).then(function(){});
        } else {
            var widgetOpl00900 = templateManager.container.getWidget('opl00900');
            //Define o comprador
            widgetOpl00900.getField("L_COMPRADOR").dataSource.data.forEach(function(item){
                if(item.CDOPERADOR === widgetOpl00900.currentRow.L_COMPRADOR[0]){
                    NMOPERADOR = item.CDOPERADOR + ' | ' + item.NMOPERADOR;
                }
            });
            //Se o processo anterior foi a exibição do relatõrio de inconsistencia
            if (relatorio_inconsistencia_confimado) {
                var filtro_apuracao_efetivacao = templateManager.container.getWidget('FILTER');
                var widgetInconsistencia = templateManager.container.getWidget('gridInconsistencia');
                var currentRowWidgetInconsistencia = widgetInconsistencia.dataSource.data[0];
                var produtos = [];
                var index = "";
                //Abre a tela de apuração/Efet... OL
                ScreenService.openWindow('opl_apuracaoEfetivacao#apuracao_efetivacao').then(function(){
                    //Widget do filtro
                    var filtro_apuracao_efetivacao = templateManager.container.getWidget('FILTER');
                    //Widget de cotação                
                    let widgetCotacao = templateManager.container.getWidget('widgetOldCot');
                    //Widget do STRIPE
                    let widgetStripe  = templateManager.container.getWidget('STRIPE');
                    setTimeout( () => {
                        //Preenche o filtro
                        filtro_apuracao_efetivacao.getField('CDCOMPRADOR').dataSourceFilter = [
                            {
                	            "name": "CDCOMPRADOR",
                		        "operator": "=",
                		        "value": widgetOpl00900.currentRow.L_COMPRADOR[0]
                		    }
                        ];
                        if(widgetOpl00900.currentRow.L_PER_LEV_AF.start !== ''){
                            filtro_apuracao_efetivacao.currentRow.DTENTREGA.start = widgetOpl00900.currentRow.L_PER_LEV_AF.start;
                        } else if (widgetOpl00900.currentRow.L_PER_LEV_PREV_CONS.start !== ''){
                            filtro_apuracao_efetivacao.currentRow.DTENTREGA.start = widgetOpl00900.currentRow.L_PER_LEV_PREV_CONS.start;
                        }
                        if(widgetOpl00900.currentRow.L_PER_LEV_AF.end !== ''){
                            filtro_apuracao_efetivacao.currentRow.DTENTREGA.end = widgetOpl00900.currentRow.L_PER_LEV_AF.end;
                        } else if (widgetOpl00900.currentRow.L_PER_LEV_PREV_CONS.end !== ''){
                            filtro_apuracao_efetivacao.currentRow.DTENTREGA.end = widgetOpl00900.currentRow.L_PER_LEV_PREV_CONS.end;
                        }
                        filtro_apuracao_efetivacao.getField('PRODUTOINI').dataSourceFilter = [
                            {
                	            "name": "NMPRODUTO",
                		        "operator": "=",
                		        "value": widgetOpl00900.currentRow.NMPRODINI
                		    }
                        ];  
                        filtro_apuracao_efetivacao.getField('PRODUTOFIN').dataSourceFilter = [
                            {
                	            "name": "NMPRODUTO",
                		        "operator": "=",
                		        "value": widgetOpl00900.currentRow.NMPRODFIN
                		    }
                        ]; 
                        filtro_apuracao_efetivacao.currentRow.CDREGIAO = widgetOpl00900.currentRow.L_REGIAO;
            			filtro_apuracao_efetivacao.currentRow.TODOS_PRODUTOS = 'N';
            			filtro_apuracao_efetivacao.currentRow.EXTRA = 'N';
                        //Habilita os fields de produtos
            			resetFieldProduto(filtro_apuracao_efetivacao.getField("LISTAFILIAL"));
            			resetFieldProduto(filtro_apuracao_efetivacao.getField("PRODUTOINI"));
            			resetFieldProduto(filtro_apuracao_efetivacao.getField("PRODUTOFIN"));
            			//Reload e setValue dos fields
            			ScreenService.showLoader();
                        filtro_apuracao_efetivacao.getField('CDCOMPRADOR').reload().then(function(response){
                            let resultCDCOMPRADOR = response.dataset.comprador_operador[0];
                            filtro_apuracao_efetivacao.getField('CDCOMPRADOR').setValue(resultCDCOMPRADOR.CDOPERADOR + " | " + resultCDCOMPRADOR.NMOPERADOR);
                            filtro_apuracao_efetivacao.currentRow.CDOPERADOR = resultCDCOMPRADOR.CDOPERADOR;
                        });
                        filtro_apuracao_efetivacao.getField('PRODUTOINI').reload().then(function(response){
                            let resultProdIni = response.dataset.produto[0];
                            filtro_apuracao_efetivacao.getField('PRODUTOINI').setValue(resultProdIni.NMPRODUTO);
                            filtro_apuracao_efetivacao.currentRow.CDPRODINI = resultProdIni.CDARVPROD;
                        });
                        filtro_apuracao_efetivacao.getField('PRODUTOFIN').reload().then(function(response){
                            let resultProdFin = response.dataset.produto[0];
                            filtro_apuracao_efetivacao.getField('PRODUTOFIN').setValue(resultProdFin.NMPRODUTO);
                            filtro_apuracao_efetivacao.currentRow.CDPRODFIN = resultProdFin.CDARVPROD;
                        });
                        if(widgetOpl00900.currentRow.L_REGIAO.length >= 1){
                            filtro_apuracao_efetivacao.getField('CDREGIAO').reload().then(function(response){
                                let resultCDREGIAO = response.dataset.regiao;
                                filtro_apuracao_efetivacao.getField('CDREGIAO').setValue(resultCDREGIAO);
                                filtro_apuracao_efetivacao.currentRow.CDREGIAO = widgetOpl00900.currentRow.L_REGIAO;
                            });
                        }
                        //Fecha o filtro
                        ScreenService.closePopup();
                        //Preenche o STRIPE
                        var widgetSTRIPE = templateManager.container.getWidget('STRIPE').currentRow;
                        widgetSTRIPE.CDPRODUTO = "";
                        widgetSTRIPE.NMPRODUTO = "";
                        widgetSTRIPE.NMOPERADOR = NMOPERADOR;
                        if(widgetOpl00900.currentRow.L_PER_LEV_AF.start !== ''){
                            widgetSTRIPE.DTINI = widgetOpl00900.currentRow.L_PER_LEV_AF.start;
                        } else if (widgetOpl00900.currentRow.L_PER_LEV_PREV_CONS.start !== ''){
                            widgetSTRIPE.DTINI = widgetOpl00900.currentRow.L_PER_LEV_PREV_CONS.start;
                        }
                        if(widgetOpl00900.currentRow.L_PER_LEV_AF.end !== ''){
                            widgetSTRIPE.DTFIN = widgetOpl00900.currentRow.L_PER_LEV_AF.end;
                        } else if (widgetOpl00900.currentRow.L_PER_LEV_PREV_CONS.end !== ''){
                            widgetSTRIPE.DTFIN = widgetOpl00900.currentRow.L_PER_LEV_PREV_CONS.end;
                        }
                        //Verifica o operador
                        General.callRestEngine("opl_apuracaoEfetivacao#/qryAutGrupOp", "Row", { 'CDOPERADOR': getLocalVar("CDOPERADOR") }).then(function(response) {
                            if (response.dataset.qryAutGrupOp.PARAM != 'S') {
                                MessageService.showMessageByCode("OPR_SEM_PERMISSAO_ESC_PRECO");
                                widgetCotacao.getField('IDITMSELAPUR').events = [];
                            }
                        }.bind(this));
                        //Busca os produtos
                        General.callRestEngine("opl_apuracaoEfetivacao#/crud/adqProduto", "FilterData", [
                            {
                                'name': 'P_CDCENTCMP',
                                'operator': 'IN',
                                'value': adqParams.CDFILIAL
            				},
                            {
                                'name': 'P_NRSEQAPUR',
                                'operator': 'IN',
                                'value': nr_log_corte_ol
            				}
            			]).then(function(response) {
            			    //Armazena os dados
                            produtos = response.dataset.adqProduto;
                            //Seta os dados em uma variável no local storage
                            setLocalVar('dadosAdqProduto', produtos);
                            console.log(getLocalVar('dadosAdqProduto'));
                            //Seta o index como "0"
                            index = 0;
                            if(produtos.length >= 1){
                                this.setCotacaoWithParams();    
                            } else {
                                let mensagem = 'Não há dados a serem listados para essa apuração.';
                                ScreenService.showMessage(mensagem);
                            }
                        }.bind(this));
                        setVisibleActions(widgetCotacao, true);
                        widgetCotacao.reload();
                        widgetStripe.actions.forEach(function(value, index) {
                            widgetStripe.actions[index].isVisible = true;
                        }.bind(this));
                        
                        /* Faz uma requisição em 'Cotação' filtrando com o produto selecionado
                        * no 'STRIPE'.
                        */
                        function getCotacoes() {
                            templateManager.container.getWidget('STRIPE').currentRow.CDPRODUTO = produtos[index].CDARVPROD;
                            templateManager.container.getWidget('STRIPE').currentRow.NMPRODUTO = produtos[index].NMPRODUTO;
                            //Retorna os dados da cotação
                            return General.callRestEngine("opl_apuracaoEfetivacao#/adqCotacao", "Row", {
                                'P_CDCENTCMP': adqParams.CDFILIAL,
                                'P_CDPRODESTO': produtos[index].CDPRODUTO,
                                'P_NRSEQAPUR': nr_log_corte_ol,
                                'P_CDFILIOPELOG': adqParams.CDFILIAL
                            }).then(function(response){
                                const widgetCotacao = templateManager.container.getWidget('widgetOldCot');
                                var widProd = templateManager.container.getWidget('PRODUTOS');
                                widgetCotacao.activate();
                                widgetCotacao.dataSource.setData(response.dataset.cotacao[0]);
                                widProd.dataSource.setData(produtos);
                                widgetCotacao.reload();
                                widProd.reload();
                                widProd.redraw();
                                if (widgetCotacao.dataSource.data.VRPRECUNIAP == 0) {
                                    MessageService.showMessageByCode("PRECO_UNIT_INFORMADO");
                                }
                            }).catch(function(error) {
                                ScreenService.showMessage(error.data ? error.data.error : messages.timeout, 'error', 'error');
                            }); 
                        }
                        
                        this.setCotacaoWithParams = function() {
                            return getCotacoes();
                        };
                        
                        ScreenService.hideLoader();
                    }, 2000);
                });
            }
        }
    };
    
    //Reseta os Fields de Produto
    var resetFieldProduto = function(field) {
        field.readOnly = false;
		deepClearField(field);
		if (field.widget.currentRow.$error) {
        	delete field.widget.currentRow.$error[field.name];
		}
		if (field.name === 'PRODUTOINI' || field.name === 'PRODUTOFIN'){
    		field.validations = {};
		}
    };
    
    //Clear Field
    var deepClearField = function(field) {
        field.clearValue();
    };
    
    //Deixa os actions visiveis
    function setVisibleActions(widget, isVisible, exceptions = []) {
        widget.actions
            .filter(action => !exceptions.includes(action.name))
            .forEach(action => action.isVisible = isVisible);
    }

}

Configuration(function(ContextRegister){
    ContextRegister.register("opl00900_listagem_de_corteController", opl00900_listagem_de_corteController);
});

